// p2 tiles - scruss, 2020-10

// length of long edge, mm
long_edge   = 15;
// colour layer thickness, mm
layer       =  0.4;
// corner rounding, mm
rounding    =  0.4;

module naff() { /* customizer, pfo */ }

// nothing magic about this: it's a pentagon thing
gr          = (1 + sqrt(5)) / 2;        // golden ratio
cos36       = gr / 2;
sin36       = sqrt(1 - pow(cos36, 2));

$fn         = 40;

module kite(r) {
    polygon([
        [ 0         ,  0 ],
        [ r * cos36 , -r * sin36 ],
        [ r         ,  0 ],
        [ r * cos36 ,  r * sin36 ]
    ]);
}

module dart(r) {
    translate([-r, 0])difference() {
        translate([2 * r * cos36, 0])mirror([1,0])kite(r);
        kite(r);
    }
}

module outline(thickness) {
    difference() {
        offset(r =  thickness / 2)children();
        offset(r = -thickness / 2)children();
    }
}

module roundoff(radius) {
    offset(r = radius)offset(r = -radius)children();
}

module kite3d(r, depth, thick_scribe, thick_depth, thin_scribe, thin_depth, smooth) {
    difference() {
        linear_extrude(height=depth)roundoff(smooth)kite(r);
        union() {
            translate([0, 0, depth - thick_depth])linear_extrude(height=depth)outline(thick_scribe)circle(r = r / gr);
            translate([r, 0, depth - thin_depth])linear_extrude(height=depth)outline(thin_scribe)circle(r = r - r / gr);
        }
    }
}

module dart3d(r, depth, thick_scribe, thick_depth, thin_scribe, thin_depth, smooth) {
    difference() {
        linear_extrude(height=depth)roundoff(smooth)dart(r);
        union() {
            translate([r / gr, 0, depth - thick_depth])linear_extrude(height=depth)outline(thick_scribe)circle(r = r - r / gr);
            translate([0, 0, depth - thin_depth])linear_extrude(height=depth)outline(thin_scribe)circle(r = (r - r / gr) / gr);
        }
    }
}


translate([long_edge, 0, 0])kite3d(long_edge, 3 * layer, 2 * layer, layer, layer, 2 * layer, rounding / 2);
dart3d(long_edge, 3 * layer, 2 * layer, layer, layer, 2 * layer, rounding / 2);